;eax -> irow
;ebx -> p_inrow_up
;ecx -> cuento columnas
;edx -> p_inrow_down
;esi -> p_inrow
;edi -> p_outrow

%include "macros.mac"

%define inn [ebp+8]
%define outt [ebp+12]
%define dataOut [ebp-4]
%define dataIn [ebp-8]
%define widthstep [ebp-12]
%define filas [ebp-16]
%define cols [ebp-20]

global gaussSimple
global gaussEscalada

section .text

gaussSimple:
	convencionC 20
	mov esi, inn
	mov edi, outt
	mov eax, [esi + 8]
	mov eax, [edi + 8]
	mov eax, [esi + 68]
	mov dataIn, eax
	mov eax, [edi + 68]
	mov dataOut, eax
	mov eax, [esi + 72]
	mov widthstep, eax
	mov eax, [esi +  44]
	mov filas, eax
	mov eax, [esi + 40]
	mov cols, eax
	xor eax, eax
	
.cicloFilas:
	push eax
	mov esi, eax
	mov edx, eax
	mov edi, eax
	inc esi
	add edx, 2
	push edx
	inc edi
	mul DWORD widthstep
	add eax, dataIn
	mov ebx, eax; p_inrow_up
	mov eax, esi
	mul DWORD widthstep
	add eax, dataIn
	mov esi, eax; p_inrow
	pop edx
	mov eax, edx
	mul DWORD widthstep
	add eax, dataIn
	mov edx, eax; p_inrow_down
	push edx
	mov eax, edi
	mul DWORD widthstep
	add eax, dataOut
	mov edi, eax; p_outrow, y ya tengo los 4 punteros
	pop edx
	mov ecx, cols
	shr ecx, 1

.cicloCols:
	movdqu xmm0, [esi]
	movdqu xmm1, [ebx]
	movdqu xmm2, [edx]
	
	movdqu xmm3, xmm0
	movdqu xmm4, xmm1
	movdqu xmm5, xmm2
	
	pxor xmm6, xmm6

	punpcklbw xmm0, xmm6;
	punpcklbw xmm1, xmm6; 
	punpcklbw xmm2, xmm6
	punpckhbw xmm3, xmm6; 
	punpckhbw xmm4, xmm6; 
	punpckhbw xmm5, xmm6; ahora esta todo en words, 2 pixeles por registro

	paddw xmm0, xmm1
	paddw xmm0, xmm2; sumatorias de la mitad derecha
	paddw xmm3, xmm4
	paddw xmm3, xmm5; sumatorias mitad izquierda

	pshufd xmm1, xmm0, 11101110b
	pshufd xmm2, xmm3, 01000100b
	pshufd xmm4, xmm0, 01000100b
	pshufd xmm5, xmm3, 11101110b

	paddw xmm0, xmm2
	paddw xmm0, xmm4; en xmm0 tengo [sumatoria, basura]
	paddw xmm3, xmm1
	paddw xmm3, xmm5; en xmm3 tengo [basura, sumatoria]

	punpckhwd xmm0, xmm6; 
	punpcklwd xmm3, xmm6; en ambos me quedo con el pixel sumatoria

	mov eax, 9
	pinsrd xmm6, eax, 1
	pinsrd xmm6, eax, 2
	pinsrd xmm6, eax, 3
	pinsrd xmm6, eax, 4

	cvtdq2ps xmm6, xmm6
	cvtdq2ps xmm0, xmm0
	cvtdq2ps xmm3, xmm3;los paso a flotante

	divps xmm0, xmm6; tengo los promedios
	divps xmm3, xmm6; tengo los promedios

	cvtps2dq xmm0, xmm0
	cvtps2dq xmm3, xmm3;los paso a enteros nuevamente

	packusdw xmm3, xmm6; 
	packusdw xmm6, xmm0;
	packuswb xmm6, xmm3; packeo y queda todo como al principio

	mov eax, 10000000100000001000000010000000b

	pxor xmm0, xmm0
	pinsrd xmm0, eax, 2
	pinsrd xmm0, eax, 1;esto es para armar la mascara del blend
	
	movdqu xmm2, [edi]	
	pblendvb xmm2, xmm6, xmm0; filtro los pixeles basura, para que queden los originales
	movdqu [edi], xmm2
	
	add esi, 8
	add edi, 8
	add edx, 8
	add ebx, 8

	dec ecx
	cmp ecx, 0
	jg .cicloCols
	
	pop eax
	inc eax
	mov ecx, filas
	sub ecx, 2
	cmp eax, ecx
	jl .cicloFilas

	mov eax, outt
	finConvencionC 20
	ret
