%include "macros.mac"

global laplace
global laplacesum 

section .text

%define i ebp+8
%define o ebp+12

%define in esi
%define out edi
%define columnas ebx 
%define index ecx
%define step edx 
%define filas [ebp-4] ;como los uso 1 sola vez por cada fila no vale la pena tenerlos en registros

laplace: ;void laplace(IplImage* i,IplImage* o)
	convencionC 4
	
	mov in,[i]
	mov out,[o]	 
	

	mov columnas,[in+40] ;en ebx la cantidad de columnas por procesar

	mov ecx,[in+44];la cantidad de filas en memoria
	sub ecx,2
	mov DWORD filas,ecx

	mov edx,[in+72];el step!

	mov in,[in+68] ;en esi y edi los punteros a los datos
	mov out,[out+68]
	
	lea in,[in+step]  ;bajo los punteros 1 fila
	lea out,[out+step]	

	pxor xmm7,xmm7
.cicloFilas:
	mov index,columnas
	sub index,2
	shr index,1	;como proceso de a 2 divido ecx por 2

	;in y out apuntan 1 pixel atras del q estoy procesando
	
.cicloCols:
	movups xmm0,[in+4]	;en xmm0 los pixels a procesar
	punpcklbw xmm0,xmm7	      	;multiplico por 8
	psllw xmm0,3

	movups xmm1,[in+8]	;proceso los de la fila actual	
	punpcklbw xmm1,xmm7	      

	movups xmm2,[in]	
	punpcklbw xmm2,xmm7	      

	psubusw xmm0,xmm1
	psubusw xmm0,xmm2

	lea in,[in+step]
	movups xmm1,[in+4]	;proceso los de abajo	
	punpcklbw xmm1,xmm7	      	

	movups xmm2,[in]	
	punpcklbw xmm2,xmm7	      	

	movups xmm3,[in+8]	
	punpcklbw xmm3,xmm7	      	

	psubusw xmm0,xmm1
	psubusw xmm0,xmm2
	psubusw xmm0,xmm3

	sub in,step
	sub in,step
	movups xmm1,[in+4]	;proceso los de arriba	
	punpcklbw xmm1,xmm7	      	

	movups xmm2,[in]	
	punpcklbw xmm2,xmm7	      	
	
	movups xmm3,[in+8]	
	punpcklbw xmm3,xmm7	      	

	psubusw xmm0,xmm1
	psubusw xmm0,xmm2
	psubusw xmm0,xmm3

	packuswb xmm0,xmm7
	movups [out],xmm0

	lea in,[in + step + 8]
	add out,8
	dec ecx
	jnz .cicloCols	

	mov eax,0x00000001   ;TENGO Q VER SI ES IMPAR LA CANTIDAD DE COLS
	and eax,columnas
	jz .columnasPares

	add in,4
	add out,4
.columnasPares:
	lea eax,[columnas*4]
	sub eax,step
	add in,eax
	add out,eax
	dec DWORD filas
	jnz .cicloFilas

	finConvencionC 4
	ret





%define i ebp+8
%define l ebp+12
%define o ebp+16

laplacesum: ;void laplacesum(IplImage* i,IplImage* l,IplImage* o)
	convencionC
	mov esi,[i] 		;primero calculo el tamaño total 
	mov eax,[esi+72]	;me traigo el widthStep
	mov ecx,[esi+44]	;me traigo el alto
	mul ecx
	mov ecx,eax		;en ecx la cantidad de bytes de la img
	shr ecx,4		;por eso lo divido por 16

	mov edi,[l]
	mov ebx,[o]
	
	mov esi,[esi+68] 	;cargo los punteros a los datos
	mov edi,[edi+68]
	mov ebx,[ebx+68]

.cicloSuma:
	movaps xmm0,[esi]
	movaps xmm1,[edi]
	paddusb xmm0,xmm1

	movaps [ebx],xmm0
	add esi,16
	add edi,16
	add ebx,16
	loop .cicloSuma

	finConvencionC
	ret
