%include "macros.mac"

%define in ebp+8
%define out ebp+12

%define dataOut ebp-4
%define dataIn ebp-8
%define filas ebp-12
%define cols ebp-16
%define widthStep ebp-20
%define pixCopiados ebp-24
%define TAM_PIX 8

%define tamStack 24

;eax -> 
;ebx -> irow
;ecx -> 
;edx -> icol
;esi -> p_inrow
;edi -> p_outrow

global pixelizarASM

section .text

pixelizarASM:
	convencionC tamStack

	mov eax, [in]
	mov eax, [eax+68]
	mov [dataIn], eax ;tengo en dataIn in->imageData
	mov eax, [out]
	mov eax, [eax+68]
	mov [dataOut], eax ;tengo en dataOut  out->imageData
	mov eax, [in]
	mov ecx, [eax+40]
	mov [cols], ecx	;cols = in->width
	mov ecx, [eax+44]
	mov [filas], ecx ;filas = in->height
	mov ecx, [eax+72]
	mov [widthStep], ecx ;widthStep = in->widthStep
	xor eax, eax
	mov [pixCopiados], eax ;pixeles copiados = 0

	xor ebx, ebx ;irow = 0
	.cicloFilas:
		cmp ebx, [filas]
		jge .termineFilas ;irow < filas
		
		xor eax, eax
		mov eax, [widthStep]
		mul ebx ;in->widthStep * irow
		mov esi, eax 
		add esi, [dataIn] ;p_inrow = dataIn + in->widthStep * irow
		mov edi, eax
		add edi, [dataOut] ;p_outrow = dataIn + in->widthStep * irow

		xor edx, edx ;icol = 0
		.cicloCols:
			cmp edx, [cols]
			jge .termineCols ;icol < cols

			movd xmm0, [esi]
			pshufd xmm0, xmm0, 00000000b ;me copio el pixel a repetir
			
			mov eax, [filas]
			sub eax, ebx
			cmp eax, 8
			jl .faltanFilas
			mov ecx, 8
			jmp .seguir
			.faltanFilas:
			mov ecx, eax
			.seguir:
			push edi ;salvo la direccion del primer pixel
			.copiarFilas:
				push ecx ;salvo la cantidad de filas que me faltan recorrer
				.copiarPixel:
				push edi ;me salvo la direccion del primer pixel				
				push edx ;me salvo la columna inicial
				%rep 2
				mov eax, [cols]
				sub eax, edx
				cmp eax, 4
				jl .faltanCols	;si me quedan mas de 4 columnas copio con xmm		
				movups [edi], xmm0 ;copio 4 pix
				add edi, 16
				add edx, 4
				%endrep
				
				jmp .finDeFila
				.faltanCols:
					mov ecx, [cols]
					sub ecx, edx
					cmp ecx, 0
					je .finDeFila
					mov eax, [esi]
					.copiarPix:
						mov [edi], eax
						add edi, 4
						loop .copiarPix

				.finDeFila:
				pop edx
				pop edi ;vuelvo al primer pixel
				add edi, [widthStep] ;paso a la siguiente fila
				pop ecx ;restauro las filas restantes
				loop .copiarFilas

			pop edi ;restauro la posicion del pixel inicial
			add edi, 32
			add esi, 32
			add edx, 8 ;icol+= copiados
			jmp .cicloCols
		.termineCols:
			add ebx, TAM_PIX ;irow += TAM_PIX
			jmp .cicloFilas
			
	.termineFilas:
	finConvencionC tamStack
	ret
