%include "macros.mac"

%define in ebp+8
%define out ebp+12

%define dataOut ebp-4
%define dataIn ebp-8
%define filas ebp-12
%define cols ebp-16
%define widthStepIn ebp-20
%define prow ebp-24
%define row ebp-28
%define nrow ebp-32
%define outrow ebp-36

%define tamStack 36

;eax -> 
;ebx -> 
;ecx -> 
;edx -> 
;esi -> irow
;edi -> icol

global sobelASM

section .text

sobelASM:
	convencionC tamStack

	mov eax, [in]
	mov eax, [eax+68]
	mov [dataIn], eax ;tengo en dataIn in->imageData
	mov eax, [out]
	mov ecx, [eax+68]
	mov [dataOut], ecx ;tengo en dataOut  out->imageData
	mov eax, [in]
	mov ecx, [eax+40]
	mov [cols], ecx	;cols = in->width
	mov ecx, [eax+44]
	mov [filas], ecx ;filas = in->height
	mov ecx, [eax+72]
	mov [widthStepIn], ecx ;widthStepIn = in->widthStep

	mov esi, 1 ;irow = 1
	.cicloFilas:
		mov eax, esi
		inc eax
		cmp eax, [filas]
		jge .termineFilas

		mov eax, [widthStepIn]
		mul esi
		add eax, [dataIn]
		sub eax, [widthStepIn]
		mov [prow], eax
		add eax, [widthStepIn]
		mov [row], eax ;in->imageData + in->widthStep * irow
		add eax, [widthStepIn]
		mov [nrow], eax
		
		mov eax, [widthStepIn]
		mul esi
		add eax, [dataOut] 
		mov [outrow], eax ;out->imageData + in->widthStep*irow

		xor edi, edi
		.cicloCols:
			cmp edi, [cols]
			jge .termineCols ;icol < in->width
			
			mov eax, [prow]
			movups xmm0, [eax]
			mov eax, [nrow]
			movups xmm2, [eax]

			movdqu xmm3, xmm0
			movdqu xmm5, xmm2
			movdqu xmm1, xmm0	;salvo xmm0
			movdqu xmm4, xmm2	;salvo xmm2
	
			pxor xmm6, xmm6
	
			punpcklbw xmm0, xmm6 ;prow-1, prow
			;punpcklbw xmm1, xmm6 ;row-1, row
			punpcklbw xmm2, xmm6 ;nrow-1, nrow
			punpckhbw xmm3, xmm6 ;prow+1, prow+2
			;punpckhbw xmm4, xmm6 ;row+1, row+2
			punpckhbw xmm5, xmm6 ;nrow+1, nrow+2
			;ahora esta todo en words, 2 pixeles por registro
			mov eax, 1
			pinsrw xmm7, eax, 0
			pshuflw xmm7, xmm7, 00000000b
			mov eax, 2
			pinsrw xmm7, eax, 4
			pshufhw xmm7, xmm7, 00000000b
			pmullw xmm0, xmm7 ;prow-1, 2*prow
			mov eax, 1
			pinsrw xmm7, eax, 0
			pshuflw xmm7, xmm7, 00000000b
			mov eax, 0
			pinsrw xmm7, eax, 4
			pshufhw xmm7, xmm7, 00000000b
			pmullw xmm3, xmm7 ;prow+1, 0*prow+2
			mov eax, -1
			pinsrw xmm7, eax, 0
			pshuflw xmm7, xmm7, 00000000b
			mov eax, -2
			pinsrw xmm7, eax, 4
			pshufhw xmm7, xmm7, 00000000b
			pmullw xmm2, xmm7 ;-nrow-1, -2*nrow
			mov eax, -1
			pinsrw xmm7, eax, 0
			pshuflw xmm7, xmm7, 00000000b
			mov eax, 0
			pinsrw xmm7, eax, 4
			pshufhw xmm7, xmm7, 00000000b
			pmullw xmm5, xmm7 ;-nrow-1, -2*nrow

			paddw xmm0, xmm3
			paddw xmm2, xmm5
			paddw xmm0, xmm2 
			movups xmm2, xmm0
			pshufd xmm0, xmm0, 11101110b
			pshufd xmm2, xmm2, 01000100b
			paddw xmm0, xmm2 ;sumo y tengo el kernel0

			mov eax, -1
			movd xmm2, eax
			pshufd xmm2, xmm2, 00000000b
			movdqu xmm3, xmm0
			pcmpgtw xmm3, xmm2
			pand xmm0, xmm3
			mov eax, 0x00FF00FF
			movd xmm2, eax
			pshufd xmm2, xmm2, 00000000b
			pand xmm0, xmm2 ;mascara para que me quede 0 <= 255

			packuswb xmm0, xmm0; packeo y queda todo como al principio
			movd eax, xmm0 ;tengo el kernel0
			push eax ;salvo kernel0

			movdqu xmm0, xmm1	;restauro xmm0
			movdqu xmm2, xmm4	;restauro xmm1

			mov eax, [row]
			movups xmm1, [eax]

			movdqu xmm3, xmm0
			movdqu xmm4, xmm1
			movdqu xmm5, xmm2
	
			pxor xmm6, xmm6
	
			punpcklbw xmm0, xmm6 ;prow-1, prow
			punpcklbw xmm1, xmm6 ;row-1, row
			punpcklbw xmm2, xmm6 ;nrow-1, nrow
			punpckhbw xmm3, xmm6 ;prow+1, prow+2
			punpckhbw xmm4, xmm6 ;row+1, row+2
			punpckhbw xmm5, xmm6 ;nrow+1, nrow+2
			;ahora esta todo en words, 2 pixeles por registro
			mov eax, -1
			pinsrw xmm7, eax, 0
			pshuflw xmm7, xmm7, 00000000b
			mov eax, 0
			pinsrw xmm7, eax, 4
			pshufhw xmm7, xmm7, 00000000b
			pmullw xmm0, xmm7 ;prow-1, 2*prow
			mov eax, 1
			pinsrw xmm7, eax, 0
			pshuflw xmm7, xmm7, 00000000b
			mov eax, 0
			pinsrw xmm7, eax, 4
			pshufhw xmm7, xmm7, 00000000b
			pmullw xmm3, xmm7 ;prow+1, 0*prow+2
			mov eax, -2
			pinsrw xmm7, eax, 0
			pshuflw xmm7, xmm7, 00000000b
			mov eax, 0
			pinsrw xmm7, eax, 4
			pshufhw xmm7, xmm7, 00000000b
			pmullw xmm1, xmm7 ;-2*row-1, 0*row
			mov eax, 2
			pinsrw xmm7, eax, 0
			pshuflw xmm7, xmm7, 00000000b
			mov eax, 0
			pinsrw xmm7, eax, 4
			pshufhw xmm7, xmm7, 00000000b
			pmullw xmm4, xmm7 ;2*row+1, 0*row+1		
			mov eax, -1
			pinsrw xmm7, eax, 0
			pshuflw xmm7, xmm7, 00000000b
			mov eax, 0
			pinsrw xmm7, eax, 4
			pshufhw xmm7, xmm7, 00000000b
			pmullw xmm2, xmm7 ;-nrow-1, -2*nrow
			mov eax, 1
			pinsrw xmm7, eax, 0
			pshuflw xmm7, xmm7, 00000000b
			mov eax, 0
			pinsrw xmm7, eax, 4
			pshufhw xmm7, xmm7, 00000000b
			pmullw xmm5, xmm7 ;nrow+1, 0*nrow+2

			paddw xmm0, xmm3
			paddw xmm1, xmm4
			paddw xmm2, xmm5
			paddw xmm0, xmm2 
			paddw xmm0, xmm1
			movups xmm1, xmm0
			pshufd xmm0, xmm0, 11101110b
			pshufd xmm1, xmm1, 01000100b
			paddw xmm0, xmm1 ;sumo y tengo el kernel1

			mov eax, -1
			movd xmm2, eax
			pshufd xmm2, xmm2, 00000000b
			movdqu xmm3, xmm0
			pcmpgtw xmm3, xmm2
			pand xmm0, xmm3
			mov eax, 0x00FF00FF
			movd xmm2, eax
			pshufd xmm2, xmm2, 00000000b
			pand xmm0, xmm2 ;mascara para que me quede 0 <= 255

			pxor xmm2, xmm2
			punpcklwd xmm0, xmm2
			pop eax
			movd xmm1, eax
			punpcklbw xmm1, xmm2
			punpcklwd xmm1, xmm2
			cvtdq2ps xmm0, xmm0
			cvtdq2ps xmm1, xmm1
			mulps xmm0, xmm0
			mulps xmm1, xmm1
			addps xmm0, xmm1
			sqrtps xmm0, xmm0
			cvtps2dq xmm0, xmm0
			
			mov eax, -1
			movd xmm2, eax
			pshufd xmm2, xmm2, 00000000b
			movdqu xmm3, xmm0
			pcmpgtw xmm3, xmm2
			pand xmm0, xmm3
			mov eax, 0x00FF00FF
			movd xmm2, eax
			pshufd xmm2, xmm2, 00000000b
			pand xmm0, xmm2 ;mascara para que me quede 0 <= 255

			;pack AMD
			pxor xmm3, xmm3
			pcmpgtd xmm3, xmm0 ;0 > xmm2?
			mov eax, -1
			movd xmm4, eax
			pshufd xmm4, xmm4, 00000000b	
			pxor xmm3, xmm4			
			pand xmm0, xmm3 ;dejo el valor de los canales que son > 0
			mov eax, 11111111b
			movd xmm3, eax
			pshufd xmm3, xmm3, 00000000b
			pand xmm0, xmm3 ;paso cada canal a byte
			pslld xmm0, 24	
			movups xmm3, xmm0 ;copio
			pshufd xmm3, xmm3, 10010011b
			psrld xmm3, 8
			por xmm0, xmm3
			pshufd xmm3, xmm3, 10010011b
			psrld xmm3, 8
			por xmm0, xmm3
			pshufd xmm3, xmm3, 10010011b
			psrld xmm3, 8
			por xmm0, xmm3
			pshufd xmm0, xmm0, 11111111b

			;guardar
			mov eax, [outrow]
			movd [eax], xmm0
			add DWORD [outrow], 4
			add DWORD [row], 4
			add DWORD [prow], 4
			add DWORD [nrow], 4
			inc edi
			jmp .cicloCols
		.termineCols:
			inc esi
			jmp .cicloFilas
	.termineFilas:
	finConvencionC tamStack
	ret
